local node, nodeO, nodeTmp -- tu jest [node] a jedna globalna to [nodes]!!
local id, key, active
local x, y, g, x1, y1, x2, y2

function aStarPreset()
	node, nodeTmp = {}, {}
	
	id = 1
	for y=1,#map do
		for x=1,#map[y] do
			if map[y][x].walkable == 1 then
					table.insert(node, {s = 1, id = id, x = x, y = y, p = -1, g = 0, h = 0 })
					nodeTmp[x..","..y] = id
				id = id + 1
			end

		end
	end

	for k, v in ipairs(node) do
		for yy = -1, 1 do
			for xx = -1, 1 do
				key = v.x+xx..","..v.y+yy
				if nodeTmp[key] and (xx ~= 0 or yy ~= 0) then
					g = xx * yy == 0 and 10 or	14
					table.insert(node[k], nodeTmp[key])
					table.insert(node[k], g)
				end
			end
		end
	end
end


function aStar(_A, _B)
	nodeO, _A.path = {}, {}

	for k, v in pairs(node) do
		v.s, v.p, v.g, v.h = 1, -1, 0, 0
	end
	
	x1, y1 = _A.x, _A.y
	x2, y2 = _B.x, _B.y

	x, y = x1, y1
	for k, v in ipairs(node) do
		node[k].h = (math.abs(x2 - x) + math.abs(y2 - y)) * 10
	end
	
	id = nodeTmp[x1..","..y1]
	node[id].s = -1
	active = node[id]

	repeat
-- [id] each entry from [node] which touches [active] add to [nodeO] and [active] make his parent and [g] = [g] parent + 10/14

		for k, v in ipairs(active) do
			if k % 2 == 1 then
				key = active[k]

				if node[key].s == 1 then
					node[key].s = 0
					node[key].p = active.id
					node[key].g = active.g + active[k+1]
					table.insert(nodeO, node[key].id)
				end
			end
		end

-- take the nodes that touche [active] and belong to [nodeO] and have different parent (not [active])
-- if [g] of such node < [g] [active] + 10/14 (direction counted from [active]) then change its parent to [active] and update its [g]

		for k, v in ipairs(active) do
			if k % 2 == 1 then
				key = active[k]
				if node[key].s == 0 and node[key].p ~= active.id then
					if active.g + active[k+1] < node[key].g then
						node[key].p = active.id
						node[key].g = active.g + active[k+1]
					end
				end
			end
		end

-- from [node0] choose a node with smallest [g] + [h] and remove it from there. In [node] make its [status] = -1 and make it active

		key, id = nil, nil
		for k, v in ipairs(nodeO) do
			if not id then
				key, id = k, v
			else
				if node[v].g + node[v].h < node[id].g + node[id].h then
					key, id = k, v
				end
			end
		end

		table.remove(nodeO, key)
		node[id].s = -1
		active = node[id]
		x, y = active.x, active.y

	until x == x2 and y == y2

	table.insert(_A.path, {x = x, y = y})
	repeat
		id = active.p
		table.insert(_A.path, {x = node[id].x, y = node[id].y})
		active = node[id]
	until active.p == -1
end
