local area, lc, rc = {}, {}, {}

bsp = {}

function generateMap()
	nodes = {}
	map = {}
	area = {}
	area[1] =	{
				status = "open",
				parent = 0,
				ax = 1, ay = 1, aw = mapW, ah = mapH,
				rx = -1, ry = -1, rw = -1, rh = -1
				}
			
	for y=1, area[1].ah do
		map[y] = {}
		for x=1, area[1].aw do
			map[y][x] =	{
						color		= {255, 255, 255, 255},
						glyph		= "",
						items		= nil,
						name		= "empty",
						units		= nil,						
						visible		= 0,
						walkable	= 0,
						x			= x,
						y			= y
						}
		end
	end

	mapDivide()
	mapRooms()
	mapTunnels()
end

function mapDivide()
	local tmp
	for lvl = 1, bspLvl do
		tmp = {}
		for k, v in ipairs(area) do
			if v.status == "open" then
				if splitter(k, v) then
					area[k].status = "hasChildren"
					table.insert(tmp, lc)
					table.insert(tmp, rc)
				else
					area[k].status = "locked"
				end
			end
		end

		for k,v in ipairs(tmp) do
			table.insert(area, tmp[k])
		end
	end
end



function splitter(_id, _data)
	local sMin, sMax, sPoint
	local ver = false
	if _data.aw >= _data.ah then
		ver = true
		sMin = _data.ax + rMin + 1 + 2 * wShift
		sMax = _data.aw - rMin - 1 - 2 * wShift
	else
		sMin = _data.ay + rMin + 1 + 2 * wShift
		sMax = _data.ah - rMin - 1 - 2 * wShift
	end
	if sMin > sMax then return false end
	sPoint = math.random(sMin, sMax)
	lc =	{
			status	=	"open",
			parent	=	_id,
			rx = -1, ry = -1, rw = -1, rh = -1
			}
	rc =	{
			status	=	"open",
			parent	=	_id,
			rx = -1, ry = -1, rw = -1, rh = -1
			}
	if ver then
		lc.ax, lc.ay, lc.aw, lc.ah = _data.ax, _data.ay, sPoint, _data.ah
		rc.ax, rc.ay, rc.aw, rc.ah = _data.ax + sPoint - 1, _data.ay, _data.aw - sPoint + 1, _data.ah
	else
		lc.ax, lc.ay, lc.aw, lc.ah = _data.ax, _data.ay, _data.aw, sPoint
		rc.ax, rc.ay, rc.aw, rc.ah = _data.ax, _data.ay + sPoint - 1, _data.aw, _data.ah - sPoint + 1
	end
	return true
end


function mapRooms()
	for k, v in pairs(area) do
		if v.status ~= "hasChildren" then
			local limitW = rMax <= (v.aw - 2 - 2 * wShift) and rMax or v.aw - 2 - 2 * wShift
			local limitH = rMax <= (v.ah - 2 - 2 * wShift) and rMax or v.ah - 2 - 2 * wShift
			area[k].rw = math.random(rMin, limitW)
			area[k].rh = math.random(rMin, limitH)
			area[k].rx = math.random(v.ax + 1 + wShift, v.ax + v.aw - 1 - area[k].rw - wShift)
			area[k].ry = math.random(v.ay + 1 + wShift, v.ay + v.ah - 1 - area[k].rh - wShift)
			
			for y = area[k].ry, area[k].ry + area[k].rh - 1 do
				for x = area[k].rx, area[k].rx + area[k].rw - 1 do
					map[y][x].glyph = "."
					map[y][x].name = "floor"
					map[y][x].walkable = 1
					table.insert(nodes, {x = x, y = y})
				end
			end
		end
	end
end


function mapTunnels()
	local r1x, r2x, r1y, r2y, r1w, r2w, r1h, r2h, p
	local ver, caseA, caseB
	local xShare, yShare
	local xx, yy, x, y, a, b

	for k=#area,3,-2 do
		r1x, r1y, r1w, r1h = area[k-1].rx, area[k-1].ry, area[k-1].rw, area[k-1].rh
		r2x, r2y, r2w, r2h = area[k].rx, area[k].ry, area[k].rw, area[k].rh
		p = area[k].parent

		if math.random(0,1) == 0 then
			xx = math.random(r1x, r1x + r1w - 1)
			yy = math.random(r2y, r2y + r2h - 1)
		else
			xx = math.random(r2x, r2x + r2w - 1)
			yy = math.random(r1y, r1y + r1h - 1)
		end

		caseA, caseB = false, false
		if map[yy][xx].name == "empty" and not (yy >= r1y and yy <= r1y+r1h-1) and not (xx >= r2x and xx <= r2x+r2w-1) then
			caseA = true
			if (r2x > xx) and (r1y < yy) then a, b = 1, -1  end
			if (r2x > xx) and (r1y > yy) then a, b = 1, 1 end
			if (r2x < xx) and (r1y < yy) then a, b = -1, -1 end
		end

		if map[yy][xx].name == "empty" and not (yy >= r2y and yy <= r2y+r2h-1) and not (xx >= r1x and xx <= r1x+r1w-1) then
			caseB = true
			if (r1x < xx) and (r2y > yy) then a, b = -1, 1  end
			if (r1x < xx) and (r2y < yy) then a, b = -1, -1 end
			if (r1x > xx) and (r2y > yy) then a, b = 1, 1 end
		end

		if not caseA and  not caseB then
			a, b = 1, 0	-- a = 1 means horizontal tunnel
			if (r1x+r1w-1) < r2x then
				xx = r1x+r1w
			elseif (r2x+r2w-1) < r1x then
				xx = r2x+r2w
			else	--b = 1 is for vertical tunnel
				a, b = 0, 1
			end

			if (r1y+r1h-1) < r2y then
				a, b = 0, 1
				yy = r1y+r1h
			elseif (r2y+r2h-1) < r1y then
				a, b = 0, 1
				yy = r2y+r2h
			end
		end

		if a ~= 0 then		-- horizontal tunel
			x = xx
			if caseA == false and caseB == false then
				repeat	--look for the "floor" to the left
					x = x-1
				until map[yy][x].name == "floor"
			end
			repeat
				if map[yy][x].name == "empty" then table.insert(nodes, {x = x, y = yy}) end
				map[yy][x].name = "floor"
				map[yy][x].glyph = "."
				map[yy][x].walkable = 1
				x = x + a
			until map[yy][x].walkable == 1
		end
		if b ~= 0 then		-- vertical tunnel
			y = yy
			if caseA == false and caseB == false then
				repeat			-- look for the start point to the top
					y = y-1
				until map[y][xx].name == "floor"
			end
			repeat
				if map[y][xx].name == "empty" then table.insert(nodes, {x = xx, y = y}) end
				map[y][xx].name = "floor"
				map[y][xx].glyph = "."
				map[y][xx].walkable = 1
				y = y + b
			until map[y][xx].walkable == 1
		end

		area[p].rx = r1x <= r2x and r1x or r2x
		area[p].ry = r1y <= r2y and r1y or r2y
		area[p].rw = r1x+r1w-1 >= r2x+r2w-1 and r1x+r1w-area[p].rx or r2x+r2w-area[p].rx
		area[p].rh = r1y+r1h-1 >= r2y+r2h-1 and r1y+r1h-area[p].ry or r2y+r2h-area[p].ry
	end
	
	for y = 1, #map do
		for x = 1, #map[y] do
			local aNd = map[y][x]
			if aNd.name == "empty" then
				for yy = -1, 1 do
					for xx = -1, 1 do
						if map[y+yy] then
							if map[y+yy][x+xx] then
								if map[y+yy][x+xx] ~= map[y][x] then
									if map[y+yy][x+xx].name == "floor" then
										aNd.name = "wall"
										aNd.glyph = "#"
									end
								end
							end
						end
					end
				end
			end
		end
	end
end


function bsp.draw()
	if one == 0 then
		for y = 1, mapH do
			for x = 1, mapW do
				local aNd = map[y][x]
				if zet == 1 then
					if aNd.visible == 1 then
						if aNd.name == "wall" then
							love.graphics.drawq(tileset, quads[1], (x-1)*fs, (y-1)*fs)
						elseif aNd.name == "floor" then
							love.graphics.drawq(tileset, quads[2], (x-1)*fs, (y-1)*fs)
						end
						aNd.visible = 2
					end
				else
					if aNd.visible == 1 then
						love.graphics.setColor(unpack(aNd.color))
						love.graphics.print(aNd.glyph, (x-1)*fs, (y-1)*fs)
						aNd.visible = 2
						if aNd.items then
							love.graphics.setColor(unpack(items[aNd.items].color))
							love.graphics.print(items[aNd.items].glyph, (x-1)*fs, (y-1)*fs)
						end
					end
				end
			end
		end
	else
		for y = 1, mapH do
			for x = 1, mapW do
				if map[y][x].name == "wall" then
					love.graphics.drawq(tileset, quads[1], (x-1)*fs, (y-1)*fs)
				elseif map[y][x].name == "floor" then
					love.graphics.drawq(tileset, quads[2], (x-1)*fs, (y-1)*fs)
				end
			end
		end
	end
end