menu = {}

local data = 	{
				{ title = "bsp",			minV = 0,		maxV = 30,		val = bspLvl	},
				{ title = "room min",		minV = 1,		maxV = rMax,	val = rMin		},
				{ title = "room max",		minV = rMin,	maxV = 30,		val = rMax		},
				{ title = "wall distance",	minV = 0,		maxV = 5,		val = wShift	},
				{ title = "monsters",		minV = 0,		maxV = 100,	val = monNo		}
				}

local lineNo = 1

function menu.keyPressed(key)
	if key == "down" and lineNo < #data then
		lineNo = lineNo + 1
	end
	if key == "up" and lineNo > 1 then
		lineNo = lineNo - 1
	end
	if key == "left" and data[lineNo].val > data[lineNo].minV then
		data[lineNo].val = data[lineNo].val - 1
	end
	if key == "right" and data[lineNo].val < data[lineNo].maxV then
		data[lineNo].val = data[lineNo].val + 1
	end
	bspLvl = data[1].val
	rMin = data[2].val
	rMax = data[3].val
	wShift = data[4].val
	monNo = data[5].val
	data[2].maxV = rMax
	data[3].minV = rMin
end


function menu.draw()
	love.graphics.setColor(200, 200, 200, 255)
	love.graphics.line(597, 0, 597, 600)
	love.graphics.line(597, 120, 800, 120)
	love.graphics.print("         @: "..hero.y..", "..hero.x,		50*fs,	0*fs)
	love.graphics.print("      name: "..map[hero.y][hero.x].name,	50*fs,	1*fs+1)					

	for i,v in ipairs(data) do
		if i == lineNo then
			love.graphics.setColor(255, 0, 0, 255)
		else
			love.graphics.setColor(200, 200, 200, 255)
		end
		if gameState == "play" then
			love.graphics.setColor(200, 200, 200, 255)
		end
		love.graphics.print(v.title.." "..v.minV.."-"..v.maxV..": "..v.val, 50 * fs, (i + 2) * fs + i + 2)
	end
	
	-- for i,v in ipairs(spdTable) do
			-- love.graphics.print(v[1].." = "..units[v[1]].action[1].." x "..units[v[1]].action[2].." -- "..units[v[1]].action[4], 50 * fs, (i + 8) * fs + i + 8)
	-- end
	-- love.graphics.print(hero.id.." - "..hero.timer, 50 * fs, (30) * fs + 30)
	
	love.graphics.print("TAB - jump to this side", 50*fs,	380)
	love.graphics.print("UP/DO/RI/LFT - chang.options", 50*fs,	400)
	love.graphics.print("ENTER - new level",	50*fs,	420)	
	love.graphics.print("1 - display whole lvl",	50*fs,	440)	
	love.graphics.print("z - swich to ASCII",	50*fs,	460)	
end